<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\group_activity;


use think\Exception;
use think\facade\Db;
use app\common\logic\BaseLogic;
use app\common\model\group_activity\GroupEquity;

/**
 * 拼团权益卡逻辑
 * Class GroupEquityLogic
 * @package app\adminapi\logic\group_activity
 */
class GroupEquityLogic extends BaseLogic
{


    /**
     * @notes 添加拼团权益卡
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            
            GroupEquity::create([
                'title' => $params['title'],
                'image' => $params['image'],
                'equity_id' => $params['equity_id'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }

    /**
     * @notes 编辑拼团权益卡
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            GroupEquity::where('id', $params['id'])->update([
                'title' => $params['title'],
                'image' => $params['image'],
                'equity_id' => $params['equity_id'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }

    /**
     * @notes 删除拼团权益卡
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public static function delete(array $params): bool
    {
        return GroupEquity::destroy($params['id']);
    }


    /**
     * @notes 获取拼团权益卡详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2025/03/13 10:31
     */
    public static function detail($params): array
    {
        $detail = GroupEquity::findOrEmpty($params['id'])->toArray();
        return $detail;
    }
}